from dataEngine import Common


class AppConfig(Common.PbxDataObject):
    def __init__(self):
        self.port = 5039
        self.driver = None
        self.out_file = None
        self.logdata_by_id = dict()
        self.isTest = False
        self.stop = False
        self.rewrite_out_file = False
        self.dump = None
        self.daemon = False
        self.mode = []
        self.compare_traces = False
        self.use_pcap_as_source = False
        self.rewrite_traces = False
        self.show_events = False
        self.loglevel = "WARNING"
        self.in_file = None
        self.ldap_file = None
        self.realtime = False
        self.cache_ldap = False
        self.full_debug = False
        self.aws_stream_name = None
        self.skip_socket = False
        self.read_pcap_simultaneously = False
        self.conf_seconds_before_stop_recording = 12
        self.conf_recording = False
        self.exit_code = 0

    def set(self, param, value):
        if value is not None:
            setattr(self, param, value)


APP_CONFIG = AppConfig()


def set(name, value):
    if name == "mode" and "auto" in value:
        if not isTest() and Common.check_license("xbees"):
            value = ['calls', 'presence']
        else:
            value = ['none']
    APP_CONFIG.set(name, value)


def get(name):
    return APP_CONFIG.get(name)


def isTest():
    return APP_CONFIG.get("isTest")


def isDaemon():
    return APP_CONFIG.get("daemon")


def isStopped():
    return APP_CONFIG.get("stop")


def checkMode(event_type):
    return event_type in APP_CONFIG.get("mode")


def get_log_data_by_id(id):
    return APP_CONFIG.logdata_by_id[id] if id in APP_CONFIG.logdata_by_id else None


def set_log_data_by_id(id, data):
    APP_CONFIG.logdata_by_id[id] = data
