import time
from threading import Thread
from dataEngine import AppConfig, Logger, Driver, Common

logger = Logger.get()

SLEEP_TIME_SEC = 5
MAX_FAILED_NUM = 3


def checker():
    counter_failed = 0
    while True:
        if AppConfig.isStopped():
            break
        if not Driver.health_check():
            counter_failed += 1
        else:
            counter_failed = 0

        if counter_failed > MAX_FAILED_NUM:
            logger.error("Stop data engine due to health check failed")
            AppConfig.set("exit_code", 1)
            AppConfig.set("stop", True)
            break
        time.sleep(SLEEP_TIME_SEC)


def init():
    if AppConfig.isTest():
        return
    thread = Thread(target=checker)
    thread.start()