from dataEngine import Logger

logger = Logger.get()

PeerPresenceState = dict()

def get_status(peer, state, regState, info=None):
    res = state
    if state == "terminated":
        res = "REGISTERED" if regState == "ONLINE" else "UNREGISTERED"
    elif state in ("confirmed", "trying"):
        res = "TALKING"
    elif state == "early":
        res = "RINGING"
    elif state == "early|confirmed":
        res = "RT"
    if peer in PeerPresenceState and PeerPresenceState[peer] == res and not info:
        logger.debug("Skip send event PRESENCE for %s (%s)" % (peer, res))
        return None

    PeerPresenceState[peer] = res
    return res
